-- scene graber by SOL of Blue Logic

fileF=createfile "c:\\test.mxs"
n=$*


format "Scene graber by SOL of Blue Logic v0.1 \n" to:fileF
for a=1 to 24 do
(
	foo = getMeditMaterial a
	if foo.diffusemap != undefined then
	(
		format "Material name: %\n" foo to:fileF
		format "Material number: %\n" a to:fileF
		format "Diffuse: %\n" foo.diffuse to:fileF
		format "Ambient: %\n" foo.ambient to:fileF
		format "Specular: %\n" foo.specular to:fileF
		format "Emissive: %\n" foo.SelfIllumColor to:fileF
		format "Diffuse texture: %\n" foo.diffusemap.filename to:fileF
	)
	
)

Print n.count

ObjectCount = 0

for c in n do
(
	if c.isHidden != true then
	(
		ObjectCount += 1
	)

)

format "Object count: %\n" ObjectCount to:fileF

--for b=$* do
for b in geometry do
(
	print b
	format "Object name: %\n" b to:fileF
 	format "Type: Geometry" to:fileF

	if canConvertTo b Mesh then
	(
		DistObj=copy b
		if DistObj!=false then 
		(
			
			m=convertToMesh DistObj
			if m!=undefined then 
			(
			 	format "\nRGB: %\n" m.wirecolor to:fileF
				Print DistObj.material
				format "Material for object: %\n" DistObj.material to:fileF
--				format "MDiffusemap: %\n" DistObj.material.diffusemap to:fileF
				format "Object verts count: %\n" m.numverts to:fileF
				format "-- v[x,y,z] n[x,y,z] t[x,y,z]\n" to:fileF
				print m.numverts
				for i=1 to m.numverts do 
				(
					aade=(getvert m i)
					aaden=(getnormal m i)
					aadt=(gettvert m 2)
					if aadt!=undefined then 
					(	
						format "OVert:  % % %\n" aade aaden	aadt to:fileF
					)
					else
					(
						format "OVert:  % % [0,0,0]\n" aade aaden to:fileF
						
					)
				)
	
	--			format "Object normal verts count: %\n" m.numverts to:fileF
	--			for i=1 to m.numverts do 
	--			(
	--				aade=(getnormal m i)
	--				format "ONVert:  %\n" aade to:fileF
	--			)
	
	
				format "Object faces count: %\n" m.numfaces to:fileF
				format "-- f[v1,v2,v3]\n" to:fileF
				for i=1 to m.numfaces do 
				(
					aade=(getface m i)
					format "OFace:  % %\n" aade (getfacematid m i) to:fileF
				)
	
	
				format "Object mesh count: %\n" m.numfaces to:fileF
				format "-- v[x,y,z] n[x,y,z] t[x,y,z] mid\n" to:fileF
				for i=1 to m.numfaces do 
				(
					ffde=(getface m i)
					aade=(getvert m ffde.x)
					aaden=(getnormal m ffde.x)
					format "OMesh1:  % % % %\n" aade aaden (gettvert m ffde.x) (getfacematid m ffde.x) to:fileF
	
					aade=(getvert m ffde.y)


					aaden=(getnormal m ffde.y)
					format "OMesh2:  % % % %\n" aade aaden (gettvert m ffde.y) (getfacematid m ffde.y) to:fileF
	
					aade=(getvert m ffde.z)
					aaden=(getnormal m ffde.z)
					format "OMesh3:  % % % %\n" aade aaden (gettvert m ffde.z) (getfacematid m ffde.z) to:fileF
				)
			)
			
			delete DistObj
		)
	)
	--showProperties b
	
	if b.isAnimated !=false then
	(
	 	
		if b.pos.isAnimated != false then
		(
			format "Keys count positions: %\n" b.pos.Keys.count to:fileF
			Print b.pos.Keys.count
	
		 	format "Keys in frames: %\n" b.pos.Keys to:fileF
			
			for c=b.pos.Keys do
			(
				print c.value
			 	format "PosKey: % % % % %\n" c.value c.inTangent c.outTangent c.inTangentType c.outTangentType to:fileF
				--format "Tagent: %n" c.inTagent
				--showProperties c
			)
		)
		
		if b.rotation.isAnimated != false then
		(
			format "Keys count rotation: %\n" b.rotation.keys.count to:fileF
			Print b.rotation.keys.count
			
		 	format "Keys in frames: %\n" b.rotation.Keys to:fileF
		
			for c=b.rotation.keys do
			(
				print c.value
				format "RotKey: %\n" c.value to:fileF
			)		
		)
		
		if b.scale.isAnimated != false then
		(
			print "------------------------------"
			format "Keys count scale: %\n" b.scale.keys.count to:fileF

		 	format "Keys in frames: %\n" b.scale.Keys to:fileF
			
			for c = b.scale.keys do
			(
				format "ScaleKey: % % % % %\n" c.value c.inTangent c.outTangent c.inTangentType c.outTangentType to:fileF
			)
			

		)
		
	)
)

for b in lights do
(
	format "Object name: %\n" b to:fileF
 	format "Object type: Light\n" to:fileF
 	format "RGB: %\n" b.rgb to:fileF
	showProperties b
	if b.isAnimated !=false then
	(
	 	
		if b.pos.isAnimated != false then
		(
			format "Keys count positions: %\n" b.pos.Keys.count to:fileF
			Print b.pos.Keys.count
	
		 	format "Keys in frames: %\n" b.pos.Keys to:fileF
			
			for c=b.pos.Keys do
			(
				print c.value
			 	format "PosKey: % % % % %\n" c.value c.inTangent c.outTangent c.inTangentType c.outTangentType to:fileF
			)
		)
	)
)

for b in cameras do
(
	print b
	format "Object name: %\n" b to:fileF
	if isKindOf b camera then 
	(
 		format "fov: %\n" b.fov to:fileF
 		format "Camera type: %\n" b.type to:fileF
	)

	if b.isAnimated !=false then
	(
	 	
		if b.pos.isAnimated != false then
		(
			format "Keys count positions: %\n" b.pos.Keys.count to:fileF
			Print b.pos.Keys.count
	
			print "----------------------3333333333333333--------------"
			--showProperties b.pos.controller.key.inTangent
			
	
		 	format "Keys in frames: %\n" b.pos.Keys to:fileF
			
			for c=b.pos.Keys do
			(
				print c.value
				print c.inTangent
			 	format "PosKey: % % % % %\n" c.value c.inTangent c.outTangent c.inTangentType c.outTangentType to:fileF
			)
		)
		
		if isKindOf b camera then
		(
			if b.fov.isAnimated != false then
			(
				format "Keys count fov: %\n" b.fov.Keys.count to:fileF
				Print b.fov.Keys.count
		
			 	format "Keys in frames: %\n" b.fov.Keys to:fileF
				
				for c=b.fov.Keys do
				(
					print c.value
				 	format "FovKey: % % % % %\n" c.value c.inTangent c.outTangent c.inTangentType c.outTangentType to:fileF
				)
			)
		)
	)
)
close fileF
